---
title: Attr.namespaceURI
slug: Web/API/Attr/namespaceURI
tags:
  - API
  - DOM
  - Property
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <code><strong>Attr.namespaceURI</strong></code> read-only property returns the namespace URI of the attribute, or <code>null</code> if the element is not in a namespace.</p>

<div class="note">
<p>Before DOM4 this API was defined within the {{domxref("Node")}} interface.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>namespace</var> = <var>attribute</var>.namespaceURI</pre>

<h2 id="Example">Example</h2>

<p>In this snippet, an attribute is being examined for its {{domxref("localName")}} and its <code>namespaceURI</code>. If the <code>namespaceURI</code> returns the XUL namespace and the <code>localName</code> returns "browser", then the node is understood to be a XUL <code>&lt;browser/&gt;</code>.</p>

<pre class="brush:js">if (attribute.localName == "value" &amp;&amp;
    attribute.namespaceURI == "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul") {
  // this is a XUL value
}</pre>

<h2 id="Notes">Notes</h2>

<p>This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. The namespace URI of an attribute is frozen at the attribute creation time.</p>

<p>In Firefox 3.5 and earlier, the namespace URI for HTML attributes in HTML documents is <code>null</code>. In later versions, in compliance with HTML5, it is <code><a class="external" href="https://www.w3.org/1999/xhtml" rel="freelink">https://www.w3.org/1999/xhtml</a></code> as in XHTML. {{gecko_minversion_inline("1.9.2")}}</p>

<p>You can create an attribute with the specified <code>namespaceURI</code> using the DOM Level 2 method {{domxref("Element.setAttributeNS")}}.</p>

<p>Per the <a class="external" href="https://www.w3.org/TR/xml-names11/">Namespaces in XML</a> specification, an attribute does not inherit its namespace from the element it is attached to. If an attribute is not explicitly given a namespace, it has no namespace.</p>

<p>The DOM does not handle or enforce namespace validation per se. It is up to the DOM application to do any validation necessary. Note too that the namespace prefix, once it is associated with a particular node, cannot be changed.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-attr-namespaceuri', 'Attr: namespaceURI')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Attr.namespaceURI")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Attr.localName")}}</li>
 <li>{{domxref("Attr.prefix")}}</li>
 <li>{{domxref("Element.namespaceURI")}}</li>
 <li>{{domxref("Node.namespaceURI")}}</li>
</ul>
